;  ----------------------------LICENSE NOTICE-----------------------------
;
;  This file is part of the Hey Sailor! game for Amstrad CPC 464.
;  Copyright (C) 2019  Daniel Bravo García  (dani_jijona@hotmail.com)
;  Copyright (C) 2019  David Navas Díaz   (dnavasdiaz97@gmail.com)
;  Copyright (C) 2019  Juan Manuel Ruiz Culiañez  (pokejuanma@gmail.com)
;
;  Hey Sailor! is free software: you can redistribute it and/or modify
;  it under the terms of the GNU General Public License as published by
;  the Free Software Foundation, either version 3 of the License, or
;  (at your option) any later version.
;
;  Hey Sailor! is distributed in the hope that it will be useful,
;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;  GNU General Public License for more details.
;
;  You should have received a copy of the GNU General Public License
;  along with Hey Sailor!. If not, see <http://www.gnu.org/licenses/>.
;
; ----------------------------------------------------------------------


;; Include all CPCtelera constant definitions, macros and variables
.include "cpctelera.h.s"
.include "man/entity_manager.h.s"
.include "cpct_functions.h.s"
.include "man/game_manager.h.s"
.include "assets/music/music.h.s"
.area _DATA
.area _CODE


_update_time: .db 2



_main::
   ;; Disable firmware to prevent it from interfering with string drawing
   call cpct_disableFirmware_asm
   call game_man_start
   call game_man_init
   ;;Ponemos la musica in-game
  ld de, #_main_song
  call cpct_akp_musicInit_asm

loop:
  ld a, (_update_time)
  cp #0
  jr nz, _no_update

  _update:
  call game_man_update
  ld  a, #1
  ld (_update_time), a
  jr  _always

  _no_update:
  dec a
  ld (_update_time), a

  _always:
  call cpct_akp_musicPlay_asm
  call cpct_waitVSYNC_asm
  
  call game_man_render
  
  jr loop

  ret

