;  ----------------------------LICENSE NOTICE-----------------------------
;
;  This file is part of the Hey Sailor! game for Amstrad CPC 464.
;  Copyright (C) 2019  Daniel Bravo García  (dani_jijona@hotmail.com)
;  Copyright (C) 2019  David Navas Díaz   (dnavasdiaz97@gmail.com)
;  Copyright (C) 2019  Juan Manuel Ruiz Culiañez  (pokejuanma@gmail.com)
;
;  Hey Sailor! is free software: you can redistribute it and/or modify
;  it under the terms of the GNU General Public License as published by
;  the Free Software Foundation, either version 3 of the License, or
;  (at your option) any later version.
;
;  Hey Sailor! is distributed in the hope that it will be useful,
;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;  GNU General Public License for more details.
;
;  You should have received a copy of the GNU General Public License
;  along with Hey Sailor!. If not, see <http://www.gnu.org/licenses/>.
;
; ----------------------------------------------------------------------



;;
;;  ENTITY MANAGER
;;
  
;; PUBLIC FUNCTIONS
.globl entityman_getNumEntities_A
.globl entityman_getEntityArray_IX
.globl entityman_getEntityArray_IY
.globl entityman_getEnemyArray_IX
.globl entityman_getEnemyArray_HL
.globl entityman_getNumEnemies_A
.globl entityman_getBulletArray_IX
.globl entityman_getBulletArray_HL
.globl entityman_getNumBullets_A
.globl entityman_getFortArray_IX
.globl entityman_getFortArray_IY
.globl entityman_getFortArray_HL
.globl entityman_getNumForts_A

.globl reset_bullet_array

.globl entityman_init

.globl entityman_create
.globl entityman_create_enemy
.globl entityman_create_bullet
.globl entityman_create_fort

.globl entityman_destroy_entity
.globl entityman_destroy_enemy
.globl entityman_destroy_bullet
.globl entityman_destroy_fort

.globl check_hp

.globl create_bullet
.globl create_enemy_bullet
.globl create_enemy
.globl create_fort

.globl fort_needs_render
.globl all_forts_needs_render

max_entities == 21

;; Entity DEFINITION MACRO
.macro DefineEntityAnnonimous _x, _y, _vx, _vy, _w, _h, _hp, _type, _ai_type, _sprite
  .db _x, _y
  .db _vx, _vy
  .db _w, _h
  .db _hp
  .db _type
  .db 1       ;; variable booleana que cambia cuando hay que renderizar los fuertes
  .db _ai_type
  .db 90          ;;DANI: CONTADOR PARA SPAWN DE ENEMIGOS EN LOS FUERTES
  .db 0             ;; animacion
  .db 2             ;;cooldown animacion
  .dw _sprite     ; PARA PONER SPRITES A CADA ENTIDAD
  .db 0x00, 0x00  ;;DAVID: CREO AI aim X, AI aim Y
  .dw 0xDDDD ; Puntero a collider
  .dw 0xCCCC ; Ultima posicion guardada en memoria de video
  .dw 0xAAAA  ;Nueva posicion en la que se va a dibujar
.endm

spawn_timer = 130

;;DAVID: AQUI TAMBIEN METO EL STATUS
.macro DefineEntity _name, _x, _y, _vx, _vy, _w, _h, _hp, _type, _ai_type, _sprite
  _name::

   DefineEntityAnnonimous _x, _y, _vx, _vy, _w, _h, _hp, _type, _ai_type, _sprite
.endm

e_x          = 0
e_y          = 1
e_vx         = 2
e_vy         = 3
e_w          = 4
e_h          = 5
e_hp         = 6
e_type       = 7
e_render_fort= 8
e_ai_type    = 9
e_spawn_time = 10
e_animation  = 11
e_anim_cd    = 12
e_sp_l       = 13  ;; Parte l del sprite
e_sp_h       = 14  ;; Parte h del sprite
e_ai_aim_x   = 15  ;DAVID
e_ai_aim_y   = 16  ;DAVID: CREO ESTAS 3 Offsets y desplazo las siguientes
e_coll_ptr_l = 17
e_coll_ptr_h = 18
e_lastVP_l   = 19
e_lastVP_h   = 20
e_newVP_l    = 21
e_newVP_h    = 22
sizeof_e     = 23


;;Enum Type
e_type_player       = 0
e_type_bullet       = 1
e_type_enemy_bullet = 2
e_type_enemy        = 3
e_type_fort         = 4

;;Enum AI Type
e_ai_type_no_ai         = 0    ;;Entidad sin tipo de IA
e_ai_type_bullet_fort   = 1
e_ai_type_spawn_fort    = 2   
e_ai_type_combo_fort    = 3 
e_ai_type_follow_enemy  = 4
e_ai_type_shot_enemy    = 5


.macro DefineEntityArray _name, _N
_name::
  .rept _N
    DefineEntityAnnonimous 0xDE, 0xAD, 0xDE, 0xAD, 0xDE, 0xAD, 0xDE, 0xAD, 0xDE, 0xAD
  .endm
.endm



;; Enemy array DEFINITION MACRO
.macro DefineEnemyPtr _ptr_enemy
  .dw _ptr_enemy
.endm

ptr_enemy_l = 0
ptr_enemy_h = 1
sizeof_ptr_to_enemy = 2     ;; el puntero al enemigo ocupa 2 bytes


.macro DefineEnemyArray _name_e, _N_e
_name_e::
  .rept _N_e
    DefineEnemyPtr 0xDEAD
  .endm
.endm

;; Bullet array DEFINITION MACRO
.macro DefineBulletPtr _ptr_bullet
  .dw _ptr_bullet
.endm

ptr_bullet_l = 0
ptr_bullet_h = 1
sizeof_ptr_to_bullet = 2     ;; el puntero al enemigo ocupa 2 bytes


.macro DefineBulletArray _name_b, _N_b
_name_b::
  .rept _N_b
    DefineBulletPtr 0xBBBB
  .endm
.endm


;; Fort array DEFINITION MACRO
.macro DefineFortPtr _ptr_fort
  .dw _ptr_fort
.endm

ptr_fort_l = 0
ptr_fort_h = 1
sizeof_ptr_to_fort = 2     ;; el puntero al enemigo ocupa 2 bytes


.macro DefineFortArray _name_f, _N_f
_name_f::
  .rept _N_f
    DefineFortPtr 0xFFFF
  .endm
.endm

