;  ----------------------------LICENSE NOTICE-----------------------------
;
;  This file is part of the Hey Sailor! game for Amstrad CPC 464.
;  Copyright (C) 2019  Daniel Bravo García  (dani_jijona@hotmail.com)
;  Copyright (C) 2019  David Navas Díaz   (dnavasdiaz97@gmail.com)
;  Copyright (C) 2019  Juan Manuel Ruiz Culiañez  (pokejuanma@gmail.com)
;
;  Hey Sailor! is free software: you can redistribute it and/or modify
;  it under the terms of the GNU General Public License as published by
;  the Free Software Foundation, either version 3 of the License, or
;  (at your option) any later version.
;
;  Hey Sailor! is distributed in the hope that it will be useful,
;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;  GNU General Public License for more details.
;
;  You should have received a copy of the GNU General Public License
;  along with Hey Sailor!. If not, see <http://www.gnu.org/licenses/>.
;
; ----------------------------------------------------------------------



.include "entity_manager.h.s"
.include "level_manager.h.s"
.include "man/game_manager.h.s"
;; INPUT 
;;	A: level to load
level_loader::
	;;comprobamos que nivel queremos cargar
	cp	#0
	jr	nz, _check_1
_level_0:
	push 	af
	call load_level_0
	pop	af
_check_1:

	cp	#1
	jr	nz, _check_2
_level_1:
	push	af
	call load_level_1
	pop	af
_check_2:

	cp	#2
	jr	nz, _check_3
_level_2:
	push	af
	call load_level_2
	pop	af
_check_3:

	cp	#3
	jr	nz, _check_4
_level_3:
	push	af
	call load_level_3
	pop	af
_check_4:

	cp	#4
	jr	nz, _check_5
_level_4:
	push	af
	call load_level_4
	pop	af
_check_5:

	cp	#5
	jr	nz, _check_6
_level_5:
	push	af
	call load_level_5
	pop	af
_check_6:

	cp	#6
	jr	nz, _check_7
_level_6:
	push	af
	call load_level_6
	pop	af
_check_7:

	cp	#7
	jr	nz, _check_8
_level_7:
	push	af
	call load_level_7
	pop	af
_check_8:

	cp	#8
	jr	nz, _check_9
_level_8:
	push	af
	call load_level_8
	pop	af

_check_9:

	cp	#9
	jr	nz, _check_10
_level_9:
	push	af
	call load_level_9
	pop	af

_check_10:

	cp	#10
	jr	nz, _check_11
_level_10:
	push	af
	call load_level_10
	pop	af

_check_11:

	cp	#11
	jr	nz, _check_12
_level_11:
	push	af
	call load_level_11
	pop	af

_check_12:

	cp	#12
	jr	nz, _check_13
_level_12:
	push	af
	call load_level_12
	pop	af

_check_13:

	cp	#13
	jr	nz, _check_14
_level_13:
	push	af
	call load_level_13
	pop	af

_check_14:

	cp	#14
	jr	nz, _check_15
_level_14:
	push	af
	call load_level_14
	pop	af

_check_15:
	call game_man_desactivate_cooldown
ret


load_level_0::
	ld 	h, #60 	;; pos x
	ld	l, #60	;; pos y
	ld 	a, #e_ai_type_follow_enemy
	call create_enemy
ret

load_level_1::
	ld 	h, #10 	;; pos x
	ld	l, #70	;; pos y
	ld	a, #e_ai_type_shot_enemy
	call create_enemy
	ld 	h, #70 	;; pos x
	ld	l, #170	;; pos y
	ld 	a, #e_ai_type_follow_enemy
	call create_enemy
ret

load_level_2::
	ld 	h, #25 	;; pos x
	ld	l, #60	;; pos y
	ld	a, #e_ai_type_bullet_fort
	call create_fort

	ld 	h, #70 	;; pos x
	ld	l, #140	;; pos y
	ld 	a, #e_ai_type_follow_enemy
	call create_enemy
ret

load_level_3::
	ld 	h, #35 	;; pos x
	ld	l, #40	;; pos y
	ld	a, #e_ai_type_spawn_fort
	call create_fort

	ld 	h, #10 	;; pos x
	ld	l, #65	;; pos y
	ld	a, #e_ai_type_shot_enemy
	call create_enemy

	ld 	h, #70 	;; pos x
	ld	l, #65	;; pos y
	ld	a, #e_ai_type_shot_enemy
	call create_enemy

	;;como es el nivel 3, aumentamos una vida al jugador
	call extraLife ;; funcion que aumenta en 1 la vida del jugador
ret


load_level_4::
	ld 	h, #10 	;; pos x
	ld	l, #40	;; pos y
	ld	a, #e_ai_type_shot_enemy
	call create_enemy

	ld 	h, #5 	;; pos x
	ld	l, #80	;; pos y
	ld	a, #e_ai_type_follow_enemy
	call create_enemy

	ld 	h, #37 	;; pos x
	ld	l, #37	;; pos y
	ld	a, #e_ai_type_follow_enemy
	call create_enemy

	ld 	h, #70 	;; pos x
	ld	l, #40	;; pos y
	ld	a, #e_ai_type_shot_enemy
	call create_enemy
	
ret

load_level_5::
	ld 	h, #5 	;; pos x
	ld	l, #40	;; pos y
	ld	a, #e_ai_type_spawn_fort
	call create_fort

	ld 	h, #65 	;; pos x
	ld	l, #100	;; pos y
	ld	a, #e_ai_type_bullet_fort
	call create_fort

ret


load_level_6::
	ld 	h, #10 	;; pos x
	ld	l, #70	;; pos y
	ld	a, #e_ai_type_combo_fort
	call create_fort

	ld 	h, #65 	;; pos x
	ld	l, #40	;; pos y
	ld	a, #e_ai_type_shot_enemy
	call create_enemy
	;;como es el nivel 6, aumentamos una vida al jugador
	call extraLife ;; funcion que aumenta en 1 la vida del jugador
ret

load_level_7::
	ld 	h, #10 	;; pos x
	ld	l, #40	;; pos y
	ld	a, #e_ai_type_shot_enemy
	call create_enemy

	ld 	h, #5 	;; pos x
	ld	l, #80	;; pos y
	ld	a, #e_ai_type_follow_enemy
	call create_enemy

	ld 	h, #37 	;; pos x
	ld	l, #37	;; pos y
	ld	a, #e_ai_type_follow_enemy
	call create_enemy

	ld 	h, #74 	;; pos x
	ld	l, #80	;; pos y
	ld	a, #e_ai_type_follow_enemy
	call create_enemy

	ld 	h, #70 	;; pos x
	ld	l, #40	;; pos y
	ld	a, #e_ai_type_shot_enemy
	call create_enemy
	
ret


load_level_8::
	ld 	h, #65	;; pos x
	ld	l, #40	;; pos y
	ld	a, #e_ai_type_spawn_fort
	call create_fort

	ld 	h, #5 	;; pos x
	ld	l, #120	;; pos y
	ld	a, #e_ai_type_spawn_fort
	call create_fort
	
	ld 	h, #10 	;; pos x
	ld	l, #40	;; pos y
	ld	a, #e_ai_type_shot_enemy
	call create_enemy

	ld 	h, #70 	;; pos x
	ld	l, #40	;; pos y
	ld	a, #e_ai_type_shot_enemy
	call create_enemy
ret


load_level_9::
	ld 	h, #10 	;; pos x
	ld	l, #40	;; pos y
	ld	a, #e_ai_type_shot_enemy
	call create_enemy

	ld 	h, #5 	;; pos x
	ld	l, #80	;; pos y
	ld	a, #e_ai_type_shot_enemy
	call create_enemy

	ld 	h, #74 	;; pos x
	ld	l, #80	;; pos y
	ld	a, #e_ai_type_shot_enemy
	call create_enemy

	ld 	h, #70 	;; pos x
	ld	l, #40	;; pos y
	ld	a, #e_ai_type_shot_enemy
	call create_enemy

	;;como es el nivel 3, aumentamos una vida al jugador
	call extraLife ;; funcion que aumenta en 1 la vida del jugador
ret


load_level_10::
	ld 	h, #5 	;; pos x
	ld	l, #40	;; pos y
	ld	a, #e_ai_type_spawn_fort
	call create_fort
	
	ld 	h, #10 	;; pos x
	ld	l, #40	;; pos y
	ld	a, #e_ai_type_shot_enemy
	call create_enemy

	ld 	h, #5 	;; pos x
	ld	l, #80	;; pos y
	ld	a, #e_ai_type_follow_enemy
	call create_enemy

	ld 	h, #37 	;; pos x
	ld	l, #37	;; pos y
	ld	a, #e_ai_type_follow_enemy
	call create_enemy

	ld 	h, #74 	;; pos x
	ld	l, #80	;; pos y
	ld	a, #e_ai_type_follow_enemy
	call create_enemy

	ld 	h, #70 	;; pos x
	ld	l, #40	;; pos y
	ld	a, #e_ai_type_shot_enemy
	call create_enemy
ret


load_level_11::

	ld 	h, #60 	;; pos x
	ld	l, #40	;; pos y
	ld	a, #e_ai_type_spawn_fort
	call create_fort

	ld 	h, #35 	;; pos x
	ld	l, #80	;; pos y
	ld	a, #e_ai_type_combo_fort
	call create_fort
	

	ld 	h, #10 	;; pos x
	ld	l, #65	;; pos y
	ld	a, #e_ai_type_shot_enemy
	call create_enemy

	ld 	h, #70 	;; pos x
	ld	l, #65	;; pos y
	ld	a, #e_ai_type_shot_enemy
	call create_enemy
ret

load_level_12::
	ld 	h, #32 	;; pos x
	ld	l, #47	;; pos y
	ld	a, #e_ai_type_bullet_fort
	call create_fort

	ld 	h, #65 	;; pos x
	ld	l, #130	;; pos y
	ld	a, #e_ai_type_combo_fort
	call create_fort
	

	ld 	h, #10 	;; pos x
	ld	l, #40	;; pos y
	ld	a, #e_ai_type_shot_enemy
	call create_enemy

	ld 	h, #70 	;; pos x
	ld	l, #40	;; pos y
	ld	a, #e_ai_type_shot_enemy
	call create_enemy

ret


load_level_13::
	ld 	h, #10 	;; pos x
	ld	l, #40	;; pos y
	ld	a, #e_ai_type_shot_enemy
	call create_enemy

	ld 	h, #5 	;; pos x
	ld	l, #80	;; pos y
	ld	a, #e_ai_type_shot_enemy
	call create_enemy

	ld 	h, #37 	;; pos x
	ld	l, #37	;; pos y
	ld	a, #e_ai_type_shot_enemy
	call create_enemy

	ld 	h, #74 	;; pos x
	ld	l, #80	;; pos y
	ld	a, #e_ai_type_shot_enemy
	call create_enemy

	ld 	h, #70 	;; pos x
	ld	l, #40	;; pos y
	ld	a, #e_ai_type_shot_enemy
	call create_enemy

	;;como es el nivel 3, aumentamos una vida al jugador
	call extraLife ;; funcion que aumenta en 1 la vida del jugador
ret


load_level_14::
	ld 	h, #20 	;; pos x
	ld	l, #60	;; pos y
	ld	a, #e_ai_type_combo_fort
	call create_fort

	ld 	h, #55 	;; pos x
	ld	l, #130	;; pos y
	ld	a, #e_ai_type_combo_fort
	call create_fort

	ld 	h, #10 	;; pos x
	ld	l, #130	;; pos y
	ld	a, #e_ai_type_follow_enemy
	call create_enemy

	ld 	h, #37 	;; pos x
	ld	l, #37	;; pos y
	ld	a, #e_ai_type_follow_enemy
	call create_enemy

	ld 	h, #74 	;; pos x
	ld	l, #80	;; pos y
	ld	a, #e_ai_type_follow_enemy
	call create_enemy

	ld 	h, #70 	;; pos x
	ld	l, #130	;; pos y
	ld	a, #e_ai_type_follow_enemy
	call create_enemy
ret


extraLife:
	call entityman_getEntityArray_IX
	ld 	a, e_hp(ix)
	cp	#3
	jr	nc, _no_sube_vida
	_sube_vida:
	inc 	a
	ld	e_hp(ix), a
	_no_sube_vida:

ret